/**
 * DevExtreme (esm/renovation/ui/scheduler/view_model/appointments/utils/getSkippedHoursInRange.js)
 * Version: 21.2.4 (build 21349-0315)
 * Build date: Wed Dec 15 2021
 *
 * Copyright (c) 2012 - 2021 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
var getSkippedHoursInRange = (startDate, endDate, viewDataProvider) => {
    var startTime = startDate.getTime();
    var endTime = endDate.getTime();
    var excludedHours = 0;
    for (var time = startTime; time <= endTime; time += 864e5) {
        var checkDate = new Date(time);
        if (viewDataProvider.isSkippedDate(checkDate)) {
            excludedHours += 24
        }
    }
    return excludedHours
};
export default getSkippedHoursInRange;
